其他分享
首页 > 其他分享> > HDU 6438 Buy and Resell

HDU 6438 Buy and Resell

作者:互联网

Problem Description

The Power Cube is used as a stash of Exotic Power. There are n cities numbered 1,2,…,n where allowed to trade it. The trading price of the Power Cube in the i-th city is ai dollars per cube. Noswal is a foxy businessman and wants to quietly make a fortune by buying and reselling Power Cubes. To avoid being discovered by the police, Noswal will go to the i-th city and choose exactly one of the following three options on the i-th day:
\(1. spend ai dollars to buy a Power Cube\)
\(2. resell a Power Cube and get ai dollars if he has at least one Power Cube\)
\(3. do nothing\)
Obviously, Noswal can own more than one Power Cubes at the same time. After going to the n cities, he will go back home and stay away from the cops. He wants to know the maximum profit he can earn. In the meanwhile, to lower the risks, he wants to minimize the times of trading (include buy and sell) to get the maximum profit. Noswal is a foxy and successful businessman so you can assume that he has infinity money at the beginning.

Input

There are multiple test cases. The first line of input contains a positive integer \(T (T≤250)\), indicating the number of test cases. For each test case:
The first line has an integer \(n\). (\(1≤n≤10^5\))
The second line has n integers \(a1,a2,…,an\) where ai means the trading price (buy or sell) of the Power Cube in the i-th city. (\(1≤ai≤10^9\))
It is guaranteed that the sum of all \(n\) is no more than \(5×10^5\).

Output

For each case, print one line with two integers —— the maximum profit and the minimum times of trading to get the maximum profit.

Sample Input

3
4
1 2 10 9
5
9 5 9 10 5
2
2 1

Sample Output

16 4
5 2
0 0

Hint

In the first case, he will buy in 1, 2 and resell in 3, 4. profit = - 1 - 2 + 10 + 9 = 16
In the second case, he will buy in 2 and resell in 4. profit = - 5 + 10 = 5
In the third case, he will do nothing and earn nothing. profit = 0

题目传送门:Buy and Resell
参考:2018中国大学生程序设计竞赛 - 网络选拔赛 hdu6438 Buy and Resell 买入卖出问题 贪心
题意:一个商人从左到右做交易,每到一个城市,可以选择买入一件商品或者卖出一件商品,求最大利润和交易的次数
思路:首先,由题意我们知道交易是有一个顺序的,只能从左到右先买入再卖出,那么基于贪心的思路显然是要在每个点找到左边最小的点来完成一次交易,题目的要求是每个点只能进行一次交易,如果我们在一个点同时进行一次买入和卖出,那么则相当于在这个点没有进行交易,由此我们也可以处理一个点在哪个点卖出能得到最大利益的问题,即假设我们在\(a2\)卖出了\(a1\),那么等到\(a2\)成为价值最小的时候,此时显然在\(a2\)处卖出\(a1\)不是最优方案,那么此时在\(ai\)处将\(a2\)卖出则相当于在\(ai\)直接卖出\(a1\)。
由上述思路,寻找左边最小值我们可以采取优先队列,确保一个点可以买入也可以卖出则将每个点压入队列两次,记录交易次数则选取每个数的第一次弹出作为一次买入卖出的交易

#include <iostream>
#include <queue>
#define int long long
using namespace std;
using PII = pair<int, int>;

signed main() {
	int t;
	scanf("%lld", &t);
	while (t--) {
		int n, ans = 0, cnt = 0;
		scanf("%lld", &n);
		priority_queue<PII> q;
		while (n--) {
			int v; scanf("%lld", &v);
			q.push({ -v, 1 });
			q.push({ -v, 0 });
			auto item = q.top(); q.pop();
			ans += v + item.first;
			if (!item.second)cnt += 2;
		}
		printf("%lld %lld\n", ans, cnt);
	}
	return 0;
}

标签:10,HDU,Buy,Power,profit,ai,卖出,Resell,he
来源: https://www.cnblogs.com/jokeBlog/p/15238844.html